<ul class="breadcrumb">
    <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
    <li><?= $this->translate('administration_module_title') ?></li>
    <li class="active"><?= $this->translate('template_module_title') ?></li>
</ul>

<h1 class="page-title">
    <?= $this->icon('project-template') ?> <?= $this->translate('template_module_title') ?>
</h1>

<div class="row row-padding">
    <div class="col-xs-12">
        <div class="panel" ng-controller="templateListController as self">
            <table-builder options="self.options" items="self.templates" class="table-builder">
                <div class="panel-heading">
                    <?= $this->translate('template_nav_list') ?>
                    <div class="panel-heading-right">
                        <div class="panel-heading-actions" tooltip="<?= $this->translate(
                        	'tooltip_remove_from_list'
                        ) ?>">
                            <?= $this->icon('eraser', 'fa-fw pointer', [
                            	'ng-click' => '__tb.removeFromList()',
                            ]) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate(
                        	'tooltip_export_xls'
                        ) ?>">
                            <?= $this->icon('excel', 'fa-fw pointer', [
                            	'ng-click' => '__tb.exportExcel()',
                            ]) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate(
                        	'tooltip_refresh'
                        ) ?>">
                            <?= $this->icon('refresh', 'fa-fw pointer', [
                            	'ng-click' => '__tb.loadData()',
                            ]) ?>
                        </div>
                    </div>
                </div>
                <div class="panel-body">
                    <div class="row">
                        <div class="col-sm-4">
                            <div class="table-filters little-panel">
                                <div class="title table-filters-header">
                                    <div class="input-group">
                                        <div class="input-group-addon pointer" data-toggle="collapse" href="#filters-collapsed">
                                            <?= $this->icon('filters', 'fa-fw') ?>
                                            <span class="caret"></span>
                                        </div>
                                        <input type="text" placeholder="<?= $this->translate(
                                        	'search',
                                        	null,
                                        	null,
                                        	false
                                        ) ?>" class="form-control"
                                               ng-model="self.fullText" id="full-text" on-enter="self.fullTextSearch()"/>
                                        <div class="input-group-addon pointer" ng-click="self.fullTextSearch()">
                                            <?= $this->icon('search', 'fa-fw') ?>
                                        </div>
                                    </div>
                                </div>
                                <div id="filters-collapsed" class="body collapse">
                                    <?php
                                    $filters = [
                                        'id' => [
                                            'label' => $this->translate('template_field_id'),
                                            'type' => 'string',
                                        ],
                                        'name' => [
                                    		'label' => $this->translate('template_field_name'),
                                    		'type' => 'string',
                                    	],
                                    	'createdAt' => [
                                    		'label' => $this->translate('template_field_createdAt'),
                                    		'type' => 'date',
                                    	],
                                    	'updatedAt' => [
                                    		'label' => $this->translate('template_field_updatedAt'),
                                    		'type' => 'date',
                                    	],
                                    ];
                                    echo $this->tableFilter(
                                    	'__tb.apiParams.search.data.filters',
                                    	$filters
                                    );
                                    ?>

                                    <div class="row">
                                        <div class="col-xs-6">
                                            <button class="btn" ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate(
                                            	'table_filter_reset_button'
                                            ) ?></button>
                                        </div>
                                        <div class="col-xs-6 text-right">
                                            <button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
                                                <?= $this->icon('search', 'fa-fw') ?>
                                                <?= $this->translate('table_filter_button') ?>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-sm-4">
                            <table-builder-columns></table-builder-columns>
                        </div>
                        <?php if ($this->acl()->isAllowed('application:e:query:r')): ?>
                            <div class="col-sm-4">
                                <table-builder-queries></table-builder-queries>
                            </div>
                        <?php endif; ?>
                    </div>
                    <div class="row">
                        <div class="col-xs-12">
                            <form name="templateForm">
                                <table table-builder-table class="table table-bordered table-condensed table-hover">
                                    <thead>
                                        <tr>
                                            <th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection"/></th>
                                            <th tb-column tb-name="id"  tb-sortable="true" tb-toggle="true"><?= $this->translate('template_field_id') ?></th>
                                            <th tb-column tb-name="name"  tb-sortable="true" tb-toggle="true"><?= $this->translate('template_field_name') ?></th>
                                            <th tb-column tb-name="default"  tb-sortable="true" tb-toggle="true"><?= $this->translate(
                                            	'template_field_default'
                                            ) ?></th>
                                            <th tb-column tb-name="createdAt"  tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate(
                                            	'template_field_createdAt'
                                            ) ?></th>
                                            <th tb-column tb-name="updatedAt"  tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate(
                                            	'template_field_updatedAt'
                                            ) ?></th>
                                            <th tb-column tb-name="actions" class="actions-column"></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr ng-repeat="template in self.templates" ng-class="{editing: self.editedLine == template}">
                                            <td><input type="checkbox" ng-model="template.selected"/></td>
                                            <td>{{template.id}}</td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== template">
                                                    <a ng-if="template._rights.read" href="<?= $this->url(
                                                    	'project/template/form'
                                                    ) ?>/{{template.id}}">{{template.name}}</a>
                                                    <span ng-if="!template._rights.read">{{template.name}}</span>

                                                    <?= $this->icon('inline-edit', '', [
                                                    	'ng-click' => 'self.editLine(template)',
                                                    	'ng-if' => 'template._rights.update',
                                                    ]) ?>
                                                </span>
                                                <span ng-if="self.editedLine == template">
                                                    <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.name" required />
                                                    <field-errors field="name" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td style="text-align: center;">
                                                <input type="checkbox" name="default" ng-model="template.default" ng-change="self.defaultTemplate(template)" ng-disabled="!template._rights.update"/>
                                            </td>
                                            <td>{{template.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>{{template.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine !== template">
                                                    <?php if (
                                                    	$this->acl()->isAllowed(
                                                    		'project:e:template:r'
                                                    	)
                                                    ): ?>
                                                        <a ng-if="template._rights.read" href="<?= $this->url(
                                                        	'project/template/form'
                                                        ) ?>/{{template.id}}" class="btn btn-xs btn-default" tooltip="<?= $this->translate(
	'tooltip_edit'
) ?>">
                                                            <?= $this->icon('edit') ?>
                                                        </a>
                                                    <?php endif; ?>

                                                    <?php if (
                                                    	$this->acl()->isAllowed(
                                                    		'project:e:template:d'
                                                    	)
                                                    ): ?>
                                                        <a ng-if="template._rights.delete" href="" class="btn btn-xs btn-default" tooltip="<?= $this->translate(
                                                        	'tooltip_delete'
                                                        ) ?>" ng-click="self.deleteTemplate(template);">
                                                            <?= $this->icon('delete') ?>
                                                        </a>
                                                    <?php endif; ?>
                                                </div>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine == template">
                                                    <button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(template)" type="submit" tooltip="<?= $this->translate(
                                                    	'tooltip_save'
                                                    ) ?>">
                                                        <?= $this->icon('save') ?>
                                                    </button>
                                                    <button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate(
                                                    	'tooltip_cancel'
                                                    ) ?>">
                                                        <?= $this->icon('close') ?>
                                                    </button>
                                                </div>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </form>
                        </div>
                    </div>
                </div>
            </table-builder>
        </div>
    </div>
</div>

<?php
$fabLinks = [];

if ($this->acl()->isAllowed('project:e:template:c')) {
	$fabLinks[] = [
		'href' => $this->url('project/template/form'),
		'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('template_nav_form'),
	];
}

echo $this->fabMenu($fabLinks);
?>

<?php
$this->angular('js/src/project/service/template.js');
$this->angular('js/src/application/query/service/query.js');

$this->angular('js/src/project/controller/template/list.js');

